// include the library code
void(* resetFunc) (void) = 0;

#define BLYNK_TEMPLATE_ID "TMPL6OS5ajd7"
#define BLYNK_DEVICE_NAME "Potty Device Pet"
#define BLYNK_AUTH_TOKEN "yXDvy8NCAbsGF9jpKU-1Jg_VLuezQ9KJ"

// Comment this out to disable prints and save space
#define BLYNK_PRINT Serial




#include <Preferences.h>
#include <WiFi.h>
#include <WiFiClient.h>
#include <BlynkSimpleEsp32.h>


char auth[] = BLYNK_AUTH_TOKEN;

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "YP3Y21-XFINIT";
char pass[] = "BASHA200";

BlynkTimer timer;

//Connections

// pin 4 from top is tx and pin

int Built_IN_Led = 2;



//Logical Operation Variables
int Auto_Manual_Selector_Relay_1 = 0;
float Weight_Sensor = 0;
int Moisture_Sensor = 0;
int Message = 0;
int Treat_Output_STS = 0;
int Weight_Setpoint = 0;

Preferences preferences;

BLYNK_WRITE(V1)
{
  int pinValue = param.asInt(); // assigning incoming value from pin V1 to a variable
  // You can also use:
  // String i = param.asStr();
  // double d = param.asDouble();
  Serial.print("V1 Message is: ");
  Serial.println(pinValue);
  Message = pinValue;
  preferences.putUInt("IN_1", Message);
}


BLYNK_WRITE(V5)
{
  //int pinValue = param.asInt(); // assigning incoming value from pin V1 to a variable
  // You can also use:
  // String i = param.asStr();
  double d = param.asDouble();
  Serial.print("V5 Weight Setpoint is: ");
  Serial.println(d);
  Weight_Setpoint = d;
  preferences.putUInt("IN_2", Weight_Setpoint);
}

void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  Serial.println("ESP32 Pet Potty Control Solution Setup Stage");
  preferences.begin("EEPROM_AWS", false);
  GettingSavedValues();
  timer.setInterval(1L, Communicating_With_Nano);
  timer.setInterval(2000L, UploadToCloud);
  Blynk.begin(auth, ssid, pass);
}

void loop() {
  // put your main code here, to run repeatedly:
  Blynk.run();
  timer.run();

}

void Communicating_With_Nano() {

  Serial.print("\r");
  Serial.print(Message);
  Serial.print("\t");
  Serial.print(Weight_Setpoint);
  Serial.print("\a");
  Serial.println("...");
  Serial.flush();
  waiting();

  String reply0;
  String reply1;
  String reply2;
  String reply3;
  reply0 = Serial.readStringUntil('\b');
  reply1 = Serial.readStringUntil('\e');
  reply2 = Serial.readStringUntil('\f');
  reply3 = Serial.readStringUntil('\v');


  Serial.print("From Nano Controller: "); Serial.println(reply1);
  Serial.print("From Nano Controller: "); Serial.println(reply2);
  Serial.print("From Nano Controller: "); Serial.println(reply3);

  Weight_Sensor = reply1.toFloat();
  Moisture_Sensor = reply2.toInt();
  Treat_Output_STS = reply3.toInt();


  Serial.print("Weight_Sensor = ");
  Serial.println(Weight_Sensor);
  Serial.print("Moisture_Sensor = ");
  Serial.println(Moisture_Sensor);
  Serial.print("Treat_Output_STS = ");
  Serial.println(Treat_Output_STS);

}

void waiting() { // 30 ms waiting Time

  digitalWrite(Built_IN_Led, HIGH);
  delay(10);
  digitalWrite(Built_IN_Led, LOW);
  delay(10);
  digitalWrite(Built_IN_Led, HIGH);
  delay(10);

}

void UploadToCloud() {

  Blynk.virtualWrite(V2, Weight_Sensor);
  Blynk.virtualWrite(V3, Moisture_Sensor);

  if (Treat_Output_STS == 1) {
    Blynk.virtualWrite(V4, 255);
  } else if (Treat_Output_STS == 0) {
    Blynk.virtualWrite(V4, 0);
  }



}


void GettingSavedValues() {

  Message = preferences.getUInt("IN_1", 0);
  Weight_Setpoint = preferences.getUInt("IN_2", 0);

  Serial.println("***********************************SAVED_EEPROM_VALUES**************************************");

  Serial.print("Message = ");
  Serial.println(Message);

  Serial.print("Weight_Setpoint = ");
  Serial.println(Weight_Setpoint);



}
